<div
  class="full-width action-step-main-grid m-t-5"
  #grid
  [class.collapsed]="!actionStep.extended"
>
  <div
    #header
    class="header-action"
    [class.header-collapsed]="!actionStep.extended"
  >
    @if (actionStep.extended) {
      <i
        [attr.data-test-element-id]="'collapse-step'"
        class="m-r-10"
        nz-icon
        nzType="caret-down"
        nzTheme="outline"
        (click)="toggleStep(actionStep)"
      ></i>
      <span class="header-color">{{
        'sqtm-core.entity.test-step.action.singular' | translate
      }}</span>
      <div
        class="action-resize-handler"
        sqtmCoreResizable
        (resize)="handleResize($event)"
      ></div>
    } @else {
      <div class="flex-fixed-size">
        <i
          [attr.data-test-element-id]="'expend-step'"
          class="m-r-10"
          nz-icon
          nzType="caret-right"
          nzTheme="outline"
          (click)="toggleStep(actionStep)"
        ></i>
        <span class="header-color"
          >{{
            'sqtm-core.entity.test-step.action.singular' | translate
          }}
          :&nbsp;</span
        >
      </div>
      <div
        class="full-height full-width header-collapsed-rich-text m-l-5 m-r-5"
        [innerHTML]="actionStep.action | safeRichContent"
        (click)="openCollapsedAction(actionStep)"
      ></div>
    }
  </div>
  <div class="header-result" [class.header-collapsed]="!actionStep.extended">
    @if (actionStep.extended) {
      <span class="header-color">{{
        'sqtm-core.entity.test-step.expected-result.label' | translate
      }}</span>
    } @else {
      <div class="flex-fixed-size">
        <span class="header-color"
          >{{
            'sqtm-core.entity.test-step.expected-result.label' | translate
          }}
          :</span
        >&nbsp;
      </div>
      <div
        class="full-height full-width header-collapsed-rich-text m-l-5"
        [innerHTML]="actionStep.expectedResult"
        (click)="openCollapsedResult(actionStep)"
      ></div>
    }
  </div>
  <div
    class="flex-fixed-size buttons-area"
    [attr.data-test-element-id]="'button-area'"
  >
    <div
      #buttons
      class="action-buttons-wrapper step-list-element-buttons full-width"
    >
      <div class="action-buttons flex-row full-width">
        @if (editable) {
          <i
            class="m-r-5 tree-icon-size current-workspace-button"
            nz-icon
            nzType="sqtm-core-generic:plus"
            nzTheme="outline"
            (click)="addActionStepAfter(this.actionStep.stepOrder)"
            nz-tooltip
            [nzTooltipTitle]="
              'sqtm-core.test-case-workspace.test-steps.button.add-step'
                | translate
            "
            [attr.data-test-button-id]="'addActionStepAfter'"
          ></i>
        }
        <i
          class="m-r-5 tree-icon-size current-workspace-button"
          nz-icon
          nzType="sqtm-core-generic:copy"
          nzTheme="outline"
          (click)="copyStep(this.actionStep)"
          nz-tooltip
          [nzTooltipTitle]="
            'sqtm-core.test-case-workspace.test-steps.button.copy' | translate
          "
          [attr.data-test-button-id]="'copy'"
        ></i>
        @if (editable) {
          <sqtm-core-toggle-icon
            class="m-r-5"
            [active]="hasCopiedSteps$ | async"
            (clickedInActiveMode)="pasteStep(this.actionStep)"
          >
            <i
              class="tree-icon-size"
              nz-icon
              nzType="sqtm-core-generic:paste"
              nzTheme="fill"
              nz-tooltip
              [nzTooltipTitle]="'sqtm-core.generic.label.paste' | translate"
              [attr.data-test-button-id]="'paste'"
            ></i>
          </sqtm-core-toggle-icon>
        }
        @if (editable) {
          <i
            class="m-r-5 tree-icon-size current-workspace-button"
            nz-icon
            nzType="sqtm-core-generic:delete"
            nzTheme="outline"
            nz-tooltip
            [nzTooltipTitle]="
              'sqtm-core.entity.test-step.delete-multiple' | translate
            "
            nzTooltipPlacement="topRight"
            (click)="deleteStep(this.actionStep)"
            [attr.data-test-button-id]="'delete'"
          ></i>
        }

        <i
          [attr.data-test-toolbar-button-id]="'step-action-button'"
          class="m-r-5 tree-icon-size current-workspace-button"
          nz-icon
          nzType="sqtm-core-generic:more"
          nzTheme="outline"
          nz-dropdown
          [nzDropdownMenu]="menu"
          (nzVisibleChange)="onMenuVisibilityChange($event)"
        ></i>

        <nz-dropdown-menu #menu="nzDropdownMenu">
          <ul [attr.data-test-menu-id]="'step-action-menu'" nz-menu>
            <li
              nz-menu-item
              [attr.data-test-menu-item-id]="'add-requirement-coverage'"
              [nzDisabled]="!linkable"
              (click)="openRequirementTreePicker()"
            >
              {{ 'sqtm-core.test-case-workspace.coverages.add' | translate }}
            </li>
            <li
              nz-menu-item
              [attr.data-test-menu-item-id]="'call-test-case'"
              [nzDisabled]="!editable"
              (click)="openTestCaseTreePicker()"
            >
              {{ 'sqtm-core.test-case-workspace.call-test-case' | translate }}
            </li>
            <li
              class="hover-green"
              style="text-decoration: none"
              nz-menu-item
              [attr.data-test-menu-item-id]="'navigate-to-details'"
              [routerLink]="[
                '/',
                'detailed-test-step',
                actionStep.testCaseId,
                'step',
                this.actionStep.stepOrder
              ]"
            >
              {{
                'sqtm-core.test-case-workspace.test-steps.button.details'
                  | translate
              }}
            </li>
            @if (canAttach) {
              <li
                class="no-padding"
                nz-menu-item
                [attr.data-test-menu-item-id]="'add-attachments'"
              >
                <sqtm-core-attachment-file-selector
                  (uploadFilesEvent)="addAttachment($event)"
                  class="full-width flex-row item-style"
                >
                  {{
                    'sqtm-core.test-case-workspace.test-steps.button.add-attachment'
                      | translate
                  }}
                </sqtm-core-attachment-file-selector>
              </li>
            }
          </ul>
        </nz-dropdown-menu>
      </div>
    </div>
  </div>
  @if (actionStep.extended) {
    <div class="action block-border overflow-hidden">
      <sqtm-core-editable-rich-text
        #action
        [value]="actionStep.action"
        [editable]="editable"
        [focus]="true"
        [targetOnUpload]="{
          entityId: actionStep.id,
          attachmentListId: actionStep.attachmentList.id,
          holderType: AttachmentHolderType.ACTION_TEST_STEP
        }"
        (confirmEvent)="changeAction($event)"
        [attr.data-test-field-id]="'action'"
      ></sqtm-core-editable-rich-text>
    </div>
  }
  @if (actionStep.extended) {
    <div class="result block-border" style="min-width: 400px">
      <sqtm-core-editable-rich-text
        #expectedResult
        [value]="actionStep.expectedResult"
        [editable]="editable"
        [focus]="true"
        (confirmEvent)="changeExpectedResult($event)"
        [targetOnUpload]="{
          entityId: actionStep.id,
          attachmentListId: actionStep.attachmentList.id,
          holderType: AttachmentHolderType.ACTION_TEST_STEP
        }"
        [attr.data-test-field-id]="'result'"
      ></sqtm-core-editable-rich-text>
    </div>
  }
</div>
@if (actionStep.extended && customFields.length > 0) {
  <div style="overflow: hidden">
    <div class="m-t-10 m-b-5 header-color">
      {{ 'sqtm-core.entity.custom-field.label.plural' | translate }}
    </div>
    <div class="custom-fields m-t-10 block-border">
      @for (customField of customFields; track customField) {
        <sqtm-core-label
          [text]="customField.label"
          class="m-l-10"
        ></sqtm-core-label>
        <div>
          <sqtm-core-custom-field-widget
            [targetOnUpload]="{
              entityId: actionStep.id,
              attachmentListId: actionStep.attachmentList.id,
              holderType: AttachmentHolderType.ACTION_TEST_STEP
            }"
            [customField]="customField"
            [value]="getCfvValue(customField, actionStep)"
            [editable]="editable"
            (confirmEvent)="updateCustomFieldValue(customField, $event)"
          >
          </sqtm-core-custom-field-widget>
        </div>
      }
    </div>
  </div>
}
@if (
  actionStep.extended && actionStep.attachmentList.attachments.ids.length > 0
) {
  <div class="attachments">
    <div class="m-t-10 m-b-5 header-color">
      {{ 'sqtm-core.entity.attachment.label.long.plural' | translate }}
    </div>
    <div class="block-border p-l-10">
      <sqtm-core-attachment-list-compact
        [attachments]="getAttachments(actionStep)"
        [attachmentListId]="actionStep.attachmentList.id"
        [canAttach]="canAttach"
        (deleteAttachmentEvent)="deleteAttachment($event, actionStep.id)"
        (confirmDeleteAttachmentEvent)="
          confirmDeleteAttachmentEvent(
            $event,
            actionStep.id,
            actionStep.attachmentList.id
          )
        "
        (cancelDeleteAttachmentEvent)="
          cancelDeleteAttachmentEvent($event, actionStep.id)
        "
        (removeRejectedAttachmentEvent)="
          removeRejectedAttachment($event, actionStep.id)
        "
      >
      </sqtm-core-attachment-list-compact>
    </div>
  </div>
}
@if (actionStep.extended && actionStep.coverages.length > 0) {
  <div class="coverages">
    <div class="m-b-5 m-t-10 header-color">
      {{
        'sqtm-core.entity.requirement-version-coverage.verified.label'
          | translate
      }}
    </div>
    <div class="full-width block-border p-l-10">
      <table class="full-width coverages-table" aria-label="Coverages table">
        <tr style="display: none">
          <th scope="col">Project name</th>
          <th scope="col">Reference</th>
          <th scope="col">Name</th>
          <th scope="col">Criticality</th>
          @if (editable) {
            <th scope="col">Delete coverage</th>
          }
        </tr>
        @for (coverage of actionStep.coverages; track coverage) {
          <tr [attr.data-test-field-id]="'step-coverage-field'">
            <td
              nz-tooltip
              [sqtmCoreLabelTooltip]="coverage.projectName"
              class="txt-ellipsis"
            >
              {{ coverage.projectName }}
            </td>
            <td
              nz-tooltip
              [sqtmCoreLabelTooltip]="coverage.reference"
              class="txt-ellipsis"
            >
              {{ coverage.reference }}
            </td>
            <td
              nz-tooltip
              [sqtmCoreLabelTooltip]="coverage.name"
              class="txt-ellipsis"
            >
              <a
                [routerLink]="[
                  '/',
                  'requirement-workspace',
                  'requirement-version',
                  'detail',
                  coverage.requirementVersionId,
                  'content'
                ]"
              >
                {{ coverage.name }}
              </a>
            </td>
            <td class="coverage-criticity">
              <sqtm-core-i18n-enum-icon
                [i18nEnumItem]="getCoverageCriticality(coverage.criticality)"
              ></sqtm-core-i18n-enum-icon>
            </td>
            @if (linkable) {
              <td class="delete-coverage">
                <span
                  class="delete-coverage-icon current-workspace-main-color"
                  (click)="removeStepCoverage(coverage, actionStep.id)"
                  [attr.data-icon]="'remove-step-coverage'"
                >
                  <i nz-icon nzType="close" nzTheme="outline"></i>
                </span>
              </td>
            }
          </tr>
        }
      </table>
    </div>
  </div>
}
